<template>
  <section class="section upload-section">
    <div v-if="!collapseInput">
      <b-upload class="file-label"></b-upload>
      <b-field>
        <b-upload v-model="dropFiles" @input="onFileUpload" drag-drop>
          <section class="section">
            <div class="content has-text-centered">
              <p>
                <b-icon icon="upload" size="is-large"> </b-icon>
              </p>
              <p>Drop your photo of <span class="has-text-primary-dark has-text-weight-bold">FLOWER</span> here or click to upload</p>
            </div>
          </section>
        </b-upload>
      </b-field>
    </div>
    <SwiperNuxt v-if="relatedImages" :images="relatedImages" />
    <b-button
      class="is-primary try-again"
      v-if="collapseInput"
      @click="onTryAgain"
      >Try again</b-button
    >
  </section>
</template>

<script>
export default {
  name: "HomePage",
  data() {
    return {
      dropFiles: [],
      relatedImages: null,
      collapseInput: false,
      loading: false
    };
  },
  methods: {
    onFileUpload(value) {
      this.getRank(value);
    },
    async getRank(file) {
      const formData = new FormData();
      formData.append("file", file);
      const response = await this.$axios.$post("/api/rank", formData, {
        headers: {
          "Content-Type": "multipart/form-data"
        }
      });
      this.relatedImages = response.top_paths.map(
        (el, idx) => { return {url: process.env.STATIC_URL + el, label: response.top_flowers[idx]}}
      );
      this.collapseInput = true;
    },
    onTryAgain(){
      this.collapseInput = false
      this.relatedImages = null
    }
  }
};
</script>

<style lang="scss" scoped>
.upload-section {
}
.try-again {
  position: fixed;
  bottom: 30px;
  left: calc(50% - 60px);
  @media (max-width: 550px) {
    position: relative;
  }
}
</style>
